/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.130 Revision 1.137
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/mysql.eclass,v 1.130 2010/02/02 02:59:03 robbat2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/mysql.eclass,v 1.137 2010/03/15 18:50:43 robbat2 Exp $
4 4
5# @ECLASS: mysql.eclass 5# @ECLASS: mysql.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Author: Francesco Riosa (Retired) <vivo@gentoo.org> 7# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
8# Maintainers: MySQL Team <mysql-bugs@gentoo.org> 8# Maintainers: MySQL Team <mysql-bugs@gentoo.org>
51 ;; 51 ;;
52 *) 52 *)
53 die "Unsupported EAPI: ${EAPI}" ;; 53 die "Unsupported EAPI: ${EAPI}" ;;
54esac 54esac
55 55
56
57# @ECLASS-VARIABLE: MYSQL_PV_MAJOR
58# @DESCRIPTION:
59# Upstream MySQL considers the first two parts of the version number to be the
60# major version. Upgrades that change major version should always run
61# mysql_upgrade.
62MYSQL_PV_MAJOR="$(get_version_component_range 1-2 ${PV})"
63
56# @ECLASS-VARIABLE: MYSQL_VERSION_ID 64# @ECLASS-VARIABLE: MYSQL_VERSION_ID
57# @DESCRIPTION: 65# @DESCRIPTION:
58# MYSQL_VERSION_ID will be: 66# MYSQL_VERSION_ID will be:
59# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 67# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
60# This is an important part, because many of the choices the MySQL ebuild will do 68# This is an important part, because many of the choices the MySQL ebuild will do
77# @DESCRIPTION: 85# @DESCRIPTION:
78# Specifiy if community features are available. Possible values are 1 (yes) 86# Specifiy if community features are available. Possible values are 1 (yes)
79# and 0 (no). 87# and 0 (no).
80# Community features are available in mysql-community 88# Community features are available in mysql-community
81# AND in the re-merged mysql-5.0.82 and newer 89# AND in the re-merged mysql-5.0.82 and newer
82if [ "${PN}" == "mysql-community" ]; then 90if [ "${PN}" == "mysql-community" -o "${PN}" == "mariadb" ]; then
83 MYSQL_COMMUNITY_FEATURES=1 91 MYSQL_COMMUNITY_FEATURES=1
84elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then 92elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then
85 MYSQL_COMMUNITY_FEATURES=1 93 MYSQL_COMMUNITY_FEATURES=1
86elif [ "${PV#5.1}" != "${PV}" ] && mysql_version_is_at_least "5.1.28"; then 94elif [ "${PV#5.1}" != "${PV}" ] && mysql_version_is_at_least "5.1.28"; then
87 MYSQL_COMMUNITY_FEATURES=1 95 MYSQL_COMMUNITY_FEATURES=1
88elif [ "${PV#5.4}" != "${PV}" ] || [ "${PV#5.4}" != "${PV}" ]; then 96elif [ "${PV#5.4}" != "${PV}" ] ; then
97 MYSQL_COMMUNITY_FEATURES=1
98elif [ "${PV#5.5}" != "${PV}" ] ; then
99 MYSQL_COMMUNITY_FEATURES=1
100elif [ "${PV#6.0}" != "${PV}" ] ; then
89 MYSQL_COMMUNITY_FEATURES=1 101 MYSQL_COMMUNITY_FEATURES=1
90else 102else
91 MYSQL_COMMUNITY_FEATURES=0 103 MYSQL_COMMUNITY_FEATURES=0
92fi 104fi
93 105
108 >=sys-apps/sed-4 120 >=sys-apps/sed-4
109 >=sys-apps/texinfo-4.7-r1 121 >=sys-apps/texinfo-4.7-r1
110 >=sys-libs/readline-4.1 122 >=sys-libs/readline-4.1
111 >=sys-libs/zlib-1.2.3" 123 >=sys-libs/zlib-1.2.3"
112 124
125[[ "${PN}" == "mariadb" ]] \
126&& DEPEND="${DEPEND} libevent? ( >=dev-libs/libevent-1.4 )"
127
113# Having different flavours at the same time is not a good idea 128# Having different flavours at the same time is not a good idea
114for i in "" "-community" ; do 129for i in "mysql" "mysql-community" "mariadb" ; do
115 [[ "${i}" == ${PN#mysql} ]] || 130 [[ "${i}" == ${PN} ]] ||
116 DEPEND="${DEPEND} !dev-db/mysql${i}" 131 DEPEND="${DEPEND} !dev-db/${i}"
117done 132done
118 133
119RDEPEND="${DEPEND} 134RDEPEND="${DEPEND}
120 !minimal? ( dev-db/mysql-init-scripts ) 135 !minimal? ( dev-db/mysql-init-scripts )
121 selinux? ( sec-policy/selinux-mysql )" 136 selinux? ( sec-policy/selinux-mysql )"
130 145
131# dev-perl/DBD-mysql is needed by some scripts installed by MySQL 146# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
132PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 147PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
133 148
134# For other stuff to bring us in 149# For other stuff to bring us in
135PDEPEND="${PDEPEND} =virtual/mysql-$(get_version_component_range 1-2 ${PV})" 150PDEPEND="${PDEPEND} =virtual/mysql-${MYSQL_PV_MAJOR}"
136 151
137# Work out the default SERVER_URI correctly 152# Work out the default SERVER_URI correctly
138if [ -z "${SERVER_URI}" ]; then 153if [ -z "${SERVER_URI}" ]; then
154 [ -z "${MY_PV}" ] && MY_PV="${PV//_/-}"
155 if [ "${PN}" == "mariadb" ]; then
156 MARIA_FULL_PV="$(replace_version_separator 3 '-' ${PV})"
157 SERVER_URI="http://launchpad.net/maria/${MYSQL_PV_MAJOR}/ongoing/+download/mariadb-${MARIA_FULL_PV}.tar.gz"
139 # The community build is on the mirrors 158 # The community build is on the mirrors
140 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then 159 elif [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
141 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${PV//_/-}.tar.gz" 160 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${MY_PV}.tar.gz"
142 # The (old) enterprise source is on the primary site only 161 # The (old) enterprise source is on the primary site only
143 elif [ "${PN}" == "mysql" ]; then 162 elif [ "${PN}" == "mysql" ]; then
144 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${PV//_/-}.tar.gz" 163 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${MY_PV}.tar.gz"
145 fi 164 fi
146fi 165fi
147 166
148# Define correct SRC_URIs 167# Define correct SRC_URIs
149SRC_URI="${SERVER_URI}" 168SRC_URI="${SERVER_URI}"
153&& SRC_URI="${SRC_URI} 172&& SRC_URI="${SRC_URI}
154 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2 173 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
155 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2 174 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
156 http://dev.gentoo.org/~robbat2/distfiles/mysql-extras-${MY_EXTRAS_VER}.tar.bz2" 175 http://dev.gentoo.org/~robbat2/distfiles/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
157 176
158# PBXT engine
159mysql_version_is_at_least "5.1.12" \
160&& [[ -n "${PBXT_VERSION}" ]] \
161&& PBXT_P="pbxt-${PBXT_VERSION}" \
162&& PBXT_SRC_URI="mirror://sourceforge/pbxt/${PBXT_P}.tar.gz" \
163&& SRC_URI="${SRC_URI} pbxt? ( ${PBXT_SRC_URI} )"
164
165# Get the percona tarball if XTRADB_VER and PERCONA_VER are both set
166mysql_version_is_at_least "5.1.26" \
167&& [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]] \
168&& XTRADB_P="percona-xtradb-${XTRADB_VER}" \
169&& XTRADB_SRC_URI="http://www.percona.com/${PN}/xtradb/${PERCONA_VER}/source/${XTRADB_P}.tar.gz" \
170&& SRC_URI="${SRC_URI} xtradb? ( ${XTRADB_SRC_URI} )"
171
172DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 177DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
173HOMEPAGE="http://www.mysql.com/" 178HOMEPAGE="http://www.mysql.com/"
179if [[ "${PN}" == "mariadb" ]]; then
180 HOMEPAGE="http://askmonty.org/"
181 DESCRIPTION="MariaDB is a MySQL fork with 3rd-party patches and additional storage engines merged."
182fi
174LICENSE="GPL-2" 183LICENSE="GPL-2"
175SLOT="0" 184SLOT="0"
176IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static" 185IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static test"
177 186
178mysql_version_is_at_least "4.1" \ 187mysql_version_is_at_least "4.1" \
179&& IUSE="${IUSE} latin1" 188&& IUSE="${IUSE} latin1"
180 189
181mysql_version_is_at_least "4.1.3" \ 190mysql_version_is_at_least "4.1.3" \
188&& IUSE="${IUSE} max-idx-128" 197&& IUSE="${IUSE} max-idx-128"
189 198
190mysql_version_is_at_least "5.1" \ 199mysql_version_is_at_least "5.1" \
191|| IUSE="${IUSE} berkdb" 200|| IUSE="${IUSE} berkdb"
192 201
193mysql_version_is_at_least "5.1.12" \
194&& [[ -n "${PBXT_VERSION}" ]] \
195&& IUSE="${IUSE} pbxt"
196
197mysql_version_is_at_least "5.1.26" \
198&& [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]] \
199&& IUSE="${IUSE} xtradb"
200
201[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \ 202[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \
202&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling" 203&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling"
204
205[[ "${PN}" == "mariadb" ]] \
206&& IUSE="${IUSE} libevent"
207
208# MariaDB has integrated PBXT
209# PBXT_VERSION means that we have a PBXT patch for this PV
210# PBXT was only introduced after 5.1.12
211pbxt_patch_available() {
212 [[ "${PN}" != "mariadb" ]] \
213 && mysql_version_is_at_least "5.1.12" \
214 && [[ -n "${PBXT_VERSION}" ]]
215 return $?
216}
217
218pbxt_available() {
219 pbxt_patch_available || [[ "${PN}" == "mariadb" ]]
220 return $?
221}
222
223# Get the percona tarball if XTRADB_VER and PERCONA_VER are both set
224# MariaDB has integrated XtraDB
225# XTRADB_VERS means that we have a XTRADB patch for this PV
226# XTRADB was only introduced after 5.1.26
227xtradb_patch_available() {
228 [[ "${PN}" != "mariadb" ]] \
229 && mysql_version_is_at_least "5.1.26" \
230 && [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]]
231 return $?
232}
233
234pbxt_patch_available \
235&& PBXT_P="pbxt-${PBXT_VERSION}" \
236&& PBXT_SRC_URI="http://www.primebase.org/download/${PBXT_P}.tar.gz mirror://sourceforge/pbxt/${PBXT_P}.tar.gz" \
237&& SRC_URI="${SRC_URI} pbxt? ( ${PBXT_SRC_URI} )" \
238
239pbxt_available \
240&& IUSE="${IUSE} pbxt"
241
242xtradb_patch_available \
243&& XTRADB_P="percona-xtradb-${XTRADB_VER}" \
244&& XTRADB_SRC_URI_COMMON="${PERCONA_VER}/source/${XTRADB_P}.tar.gz" \
245&& XTRADB_SRC_URI1="http://www.percona.com/percona-builds/xtradb/${XTRADB_SRC_URI_COMMON}" \
246&& XTRADB_SRC_URI2="http://www.percona.com/${PN}/xtradb/${XTRADB_SRC_URI_COMMON}" \
247&& SRC_URI="${SRC_URI} xtradb? ( ${XTRADB_SRC_URI1} ${XTRADB_SRC_URI2} )" \
248&& IUSE="${IUSE} xtradb"
203 249
204# 250#
205# HELPER FUNCTIONS: 251# HELPER FUNCTIONS:
206# 252#
207 253
215 ewarn "test '${rawtestname}' disabled: '${reason}'" 261 ewarn "test '${rawtestname}' disabled: '${reason}'"
216 262
217 testsuite="${rawtestname/.*}" 263 testsuite="${rawtestname/.*}"
218 testname="${rawtestname/*.}" 264 testname="${rawtestname/*.}"
219 mysql_disable_file="${S}/mysql-test/t/disabled.def" 265 mysql_disable_file="${S}/mysql-test/t/disabled.def"
220 einfo "rawtestname=${rawtestname} testname=${testname} testsuite=${testsuite}" 266 #einfo "rawtestname=${rawtestname} testname=${testname} testsuite=${testsuite}"
221 echo ${testname} : ${reason} >> "${mysql_disable_file}" 267 echo ${testname} : ${reason} >> "${mysql_disable_file}"
222 268
223 # ${S}/mysql-tests/t/disabled.def 269 # ${S}/mysql-tests/t/disabled.def
224 # 270 #
225 # ${S}/mysql-tests/suite/federated/disabled.def 271 # ${S}/mysql-tests/suite/federated/disabled.def
395 myconf="${myconf} $(use_with perl bench)" 441 myconf="${myconf} $(use_with perl bench)"
396 myconf="${myconf} --enable-assembler" 442 myconf="${myconf} --enable-assembler"
397 myconf="${myconf} --with-extra-tools" 443 myconf="${myconf} --with-extra-tools"
398 myconf="${myconf} --with-innodb" 444 myconf="${myconf} --with-innodb"
399 myconf="${myconf} --without-readline" 445 myconf="${myconf} --without-readline"
446 myconf="${myconf} $(use_with ssl openssl)"
400 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)" 447 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
401 448
402 # --with-vio is not needed anymore, it's on by default and 449 # --with-vio is not needed anymore, it's on by default and
403 # has been removed from configure 450 # has been removed from configure
451 # Apply to 4.x and 5.0.[0-3]
404 if use ssl ; then 452 if use ssl ; then
405 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio" 453 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
406 fi
407
408 if mysql_version_is_at_least "5.1.11" ; then
409 myconf="${myconf} $(use_with ssl)"
410 else
411 myconf="${myconf} $(use_with ssl openssl)"
412 fi 454 fi
413 455
414 if mysql_version_is_at_least "5.0.60" ; then 456 if mysql_version_is_at_least "5.0.60" ; then
415 if use berkdb ; then 457 if use berkdb ; then
416 elog "Berkeley DB support was disabled due to build failures" 458 elog "Berkeley DB support was disabled due to build failures"
473 515
474configure_51() { 516configure_51() {
475 # TODO: !!!! readd --without-readline 517 # TODO: !!!! readd --without-readline
476 # the failure depend upon config/ac-macros/readline.m4 checking into 518 # the failure depend upon config/ac-macros/readline.m4 checking into
477 # readline.h instead of history.h 519 # readline.h instead of history.h
478 myconf="${myconf} $(use_with ssl)" 520 myconf="${myconf} $(use_with ssl ssl /usr)"
479 myconf="${myconf} --enable-assembler" 521 myconf="${myconf} --enable-assembler"
480 myconf="${myconf} --with-geometry" 522 myconf="${myconf} --with-geometry"
481 myconf="${myconf} --with-readline" 523 myconf="${myconf} --with-readline"
482 myconf="${myconf} --with-row-based-replication"
483 myconf="${myconf} --with-zlib=/usr/$(get_libdir)" 524 myconf="${myconf} --with-zlib-dir=/usr/"
484 myconf="${myconf} --without-pstack" 525 myconf="${myconf} --without-pstack"
485 use max-idx-128 && myconf="${myconf} --with-max-indexes=128" 526 use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
527 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
528 myconf="${myconf} $(use_enable community community-features)"
529 if use community; then
530 myconf="${myconf} $(use_enable profiling)"
531 else
532 myconf="${myconf} --disable-profiling"
533 fi
534 fi
486 535
487 # 5.1 introduces a new way to manage storage engines (plugins) 536 # 5.1 introduces a new way to manage storage engines (plugins)
488 # like configuration=none 537 # like configuration=none
489 local plugins="csv,myisam,myisammrg,heap" 538 local plugins="csv,myisam,myisammrg,heap"
490 if use extraengine ; then 539 if use extraengine ; then
491 # like configuration=max-no-ndb, archive and example removed in 5.1.11 540 # like configuration=max-no-ndb, archive and example removed in 5.1.11
492 # not added yet: ibmdb2i 541 # not added yet: ibmdb2i
493 # Not supporting as examples: example,daemon_example,ftexample 542 # Not supporting as examples: example,daemon_example,ftexample
494 plugins="${plugins},archive,blackhole,federated,partition" 543 plugins="${plugins},archive,blackhole,federated,partition"
495 544
545 if [[ "${PN}" != "mariadb" ]] ; then
496 elog "Before using the Federated storage engine, please be sure to read" 546 elog "Before using the Federated storage engine, please be sure to read"
497 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 547 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
548 else
549 elog "MariaDB includes the FederatedX engine. Be sure to read"
550 elog "http://askmonty.org/wiki/index.php/Manual:FederatedX_storage_engine"
551 fi
498 fi 552 fi
499 553
500 # Upstream specifically requests that InnoDB always be built: 554 # Upstream specifically requests that InnoDB always be built:
501 # - innobase, innodb_plugin 555 # - innobase, innodb_plugin
502 # Build falcon if available for 6.x series. 556 # Build falcon if available for 6.x series.
508 if use cluster ; then 562 if use cluster ; then
509 plugins="${plugins},ndbcluster" 563 plugins="${plugins},ndbcluster"
510 myconf="${myconf} --with-ndb-binlog" 564 myconf="${myconf} --with-ndb-binlog"
511 fi 565 fi
512 566
567 if [[ "${PN}" == "mariadb" ]] ; then
568 # In MariaDB, InnoDB is packaged in the xtradb directory, so it's not
569 # caught above.
570 plugins="${plugins},maria,innobase"
571 if use pbxt ; then
572 plugins="${plugins},pbxt"
573 else
574 myconf="${myconf} --without-plugin-pbxt"
575 fi
576 myconf="${myconf} $(use_with libevent)"
577 # This is not optional, without it several upstream testcases fail.
578 # Also strongly recommended by upstream.
579 myconf="${myconf} --with-maria-tmp-tables"
580 fi
581
513 myconf="${myconf} --with-plugins=${plugins}" 582 myconf="${myconf} --with-plugins=${plugins}"
514} 583}
515 584
516pbxt_src_configure() { 585pbxt_src_configure() {
517 mysql_init_vars 586 mysql_init_vars
520 589
521 einfo "Reconfiguring dir '${PWD}'" 590 einfo "Reconfiguring dir '${PWD}'"
522 AT_GNUCONF_UPDATE="yes" eautoreconf 591 AT_GNUCONF_UPDATE="yes" eautoreconf
523 592
524 local myconf="" 593 local myconf=""
525 myconf="${myconf} --with-mysql=${S} --libdir=${D}/${MY_LIBDIR}" 594 myconf="${myconf} --with-mysql=${S} --libdir=${MY_LIBDIR}"
526 use debug && myconf="${myconf} --with-debug=full" 595 use debug && myconf="${myconf} --with-debug=full"
527 # TODO: is it safe/needed to use econf here ? 596 # TODO: is it safe/needed to use econf here ?
528 ./configure ${myconf} || die "Problem configuring PBXT storage engine" 597 ./configure ${myconf} || die "Problem configuring PBXT storage engine"
529} 598}
530 599
540 # TODO: modify test suite for PBXT 609 # TODO: modify test suite for PBXT
541} 610}
542 611
543pbxt_src_install() { 612pbxt_src_install() {
544 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 613 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
545 make install || die "Failed to install PBXT" 614 emake install DESTDIR="${D}" || die "Failed to install PBXT"
546 popd 615 popd
547} 616}
548 617
549# 618#
550# EBUILD FUNCTIONS 619# EBUILD FUNCTIONS
599 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 668 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
600 669
601 mysql_check_version_range "4.0 to 5.0.99.99" \ 670 mysql_check_version_range "4.0 to 5.0.99.99" \
602 && use berkdb \ 671 && use berkdb \
603 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 672 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
673
674 if [ "${PN}" != "mysql-cluster" ] && use cluster; then
675 ewarn "Upstream has noted that the NDB cluster support in the 5.0 and"
676 ewarn "5.1 series should NOT be put into production. In the near"
677 ewarn "future, it will be disabled from building."
678 ewarn ""
679 ewarn "If you need NDB support, you should instead move to the new"
680 ewarn "mysql-cluster package that represents that upstream NDB"
681 ewarn "development."
682 fi
604} 683}
605 684
606# @FUNCTION: mysql_src_unpack 685# @FUNCTION: mysql_src_unpack
607# @DESCRIPTION: 686# @DESCRIPTION:
608# Unpack the source code and call mysql_src_prepare for EAPI < 2. 687# Unpack the source code and call mysql_src_prepare for EAPI < 2.
637 # Now link in right patches 716 # Now link in right patches
638 mysql_mv_patches 717 mysql_mv_patches
639 # And apply 718 # And apply
640 epatch 719 epatch
641 720
721 # last -fPIC fixup, per bug #305873
722 i="${S}"/storage/innodb_plugin/plug.in
723 [ -f "${i}" ] && sed -i -e '/CFLAGS/s,-prefer-non-pic,,g' "${i}"
724
642 # Additional checks, remove bundled zlib 725 # Additional checks, remove bundled zlib
643 rm -f "${S}/zlib/"*.[ch] 726 rm -f "${S}/zlib/"*.[ch]
644 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 727 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
645 rm -f "scripts/mysqlbug" 728 rm -f "scripts/mysqlbug"
646 729
659 rm -f "scripts/mysqlbug" 742 rm -f "scripts/mysqlbug"
660 fi 743 fi
661 744
662 local rebuilddirlist d 745 local rebuilddirlist d
663 746
664 if mysql_version_is_at_least "5.1.26" && use xtradb ; then 747 if xtradb_patch_available && use xtradb ; then
665 einfo "Replacing InnoDB with Percona XtraDB" 748 einfo "Replacing InnoDB with Percona XtraDB"
666 pushd "${S}"/storage 749 pushd "${S}"/storage
667 i="innobase" 750 i="innobase"
668 o="${WORKDIR}/storage-${i}.mysql-upstream" 751 o="${WORKDIR}/storage-${i}.mysql-upstream"
669 # Have we been here already? 752 # Have we been here already?
670 [ -h "${i}" ] && rm -f "${i}" 753 [ -d "${o}" ] && rm -f "${i}"
671 # Or maybe we haven't 754 # Or maybe we haven't
672 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}" 755 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}"
673 ln -s "${WORKDIR}/${XTRADB_P}" "${i}" 756 cp -ra "${WORKDIR}/${XTRADB_P}" "${i}"
674 popd 757 popd
675 fi 758 fi
676 759
677 if mysql_version_is_at_least "5.1.12" ; then 760 if mysql_version_is_at_least "5.1.12" ; then
678 einfo "Updating innobase cmake"
679 rebuilddirlist="." 761 rebuilddirlist="."
762 # This does not seem to be needed presently. robbat2 2010/02/23
763 #einfo "Updating innobase cmake"
680 # TODO: check this with a cmake expert 764 ## TODO: check this with a cmake expert
681 cmake \ 765 #cmake \
682 -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \ 766 # -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \
683 -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \ 767 # -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \
684 "storage/innobase" 768 # "storage/innobase"
685 else 769 else
686 rebuilddirlist=". innobase" 770 rebuilddirlist=". innobase"
687 fi 771 fi
688 772
689 for d in ${rebuilddirlist} ; do 773 for d in ${rebuilddirlist} ; do
773 find . -type f -name Makefile -print0 \ 857 find . -type f -name Makefile -print0 \
774 | xargs -0 -n100 sed -i \ 858 | xargs -0 -n100 sed -i \
775 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 859 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
776 860
777 if [[ $EAPI == 2 ]]; then 861 if [[ $EAPI == 2 ]]; then
778 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_configure 862 pbxt_patch_available && use pbxt && pbxt_src_configure
779 fi 863 fi
780} 864}
781 865
782# @FUNCTION: mysql_src_compile 866# @FUNCTION: mysql_src_compile
783# @DESCRIPTION: 867# @DESCRIPTION:
784# Compile the mysql code. 868# Compile the mysql code.
785mysql_src_compile() { 869mysql_src_compile() {
786 # Be backwards compatible for now 870 # Be backwards compatible for now
787 case ${EAPI:-0} in 871 case ${EAPI:-0} in
788 2) : ;; 872 2) : ;;
789 0 | 1) mysql_src_configure ;; 873 0 | 1) mysql_src_configure ;;
790 esac 874 esac
791 875
792 emake || die "emake failed" 876 emake || die "emake failed"
793 877
794 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_compile 878 pbxt_patch_available && use pbxt && pbxt_src_compile
795} 879}
796 880
797# @FUNCTION: mysql_src_install 881# @FUNCTION: mysql_src_install
798# @DESCRIPTION: 882# @DESCRIPTION:
799# Install mysql. 883# Install mysql.
800mysql_src_install() { 884mysql_src_install() {
801 # Make sure the vars are correctly initialized 885 # Make sure the vars are correctly initialized
802 mysql_init_vars 886 mysql_init_vars
803 887
804 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed" 888 emake install \
889 DESTDIR="${D}" \
890 benchdir_root="${MY_SHAREDSTATEDIR}" \
891 testroot="${MY_SHAREDSTATEDIR}" \
892 || die "emake install failed"
805 893
806 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_install 894 pbxt_patch_available && use pbxt && pbxt_src_install
807 895
808 # Convenience links 896 # Convenience links
809 einfo "Making Convenience links for mysqlcheck multi-call binary" 897 einfo "Making Convenience links for mysqlcheck multi-call binary"
810 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze" 898 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
811 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair" 899 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
815 einfo "Removing duplicate /usr/share/mysql files" 903 einfo "Removing duplicate /usr/share/mysql files"
816 rm -Rf "${D}/usr/share/info" 904 rm -Rf "${D}/usr/share/info"
817 for removeme in "mysql-log-rotate" mysql.server* \ 905 for removeme in "mysql-log-rotate" mysql.server* \
818 binary-configure* my-*.cnf mi_test_all* 906 binary-configure* my-*.cnf mi_test_all*
819 do 907 do
820 rm -f "${D}"/usr/share/mysql/${removeme} 908 rm -f "${D}"/${MY_SHAREDSTATEDIR}/${removeme}
821 done 909 done
822 910
823 # Clean up stuff for a minimal build 911 # Clean up stuff for a minimal build
824 if use minimal ; then 912 if use minimal ; then
825 einfo "Remove all extra content for minimal build" 913 einfo "Remove all extra content for minimal build"
826 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench} 914 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench}
827 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 915 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
828 rm -f "${D}/usr/sbin/mysqld" 916 rm -f "${D}/usr/sbin/mysqld"
829 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 917 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
918 fi
919
920 # Unless they explicitly specific USE=test, then do not install the
921 # testsuite. It DOES have a use to be installed, esp. when you want to do a
922 # validation of your database configuration after tuning it.
923 if use !test ; then
924 rm -rf "${D}"/${MY_SHAREDSTATEDIR}/mysql-test
830 fi 925 fi
831 926
832 # Configuration stuff 927 # Configuration stuff
833 if mysql_version_is_at_least "4.1" ; then 928 if mysql_version_is_at_least "4.1" ; then
834 mysql_mycnf_version="4.1" 929 mysql_mycnf_version="4.1"
865 done 960 done
866 fi 961 fi
867 962
868 # Docs 963 # Docs
869 einfo "Installing docs" 964 einfo "Installing docs"
870 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 965 dodoc README ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE
871 doinfo "${S}"/Docs/mysql.info 966 doinfo "${S}"/Docs/mysql.info
872 967
873 # Minimal builds don't have the MySQL server 968 # Minimal builds don't have the MySQL server
874 if ! use minimal ; then 969 if ! use minimal ; then
875 einfo "Including support files and sample configurations" 970 einfo "Including support files and sample configurations"
877 for script in \ 972 for script in \
878 "${S}"/support-files/my-*.cnf \ 973 "${S}"/support-files/my-*.cnf \
879 "${S}"/support-files/magic \ 974 "${S}"/support-files/magic \
880 "${S}"/support-files/ndb-config-2-node.ini 975 "${S}"/support-files/ndb-config-2-node.ini
881 do 976 do
882 dodoc "${script}" 977 [[ -f "$script" ]] && dodoc "${script}"
883 done 978 done
884 979
885 docinto "scripts" 980 docinto "scripts"
886 for script in "${S}"/scripts/mysql* ; do 981 for script in "${S}"/scripts/mysql* ; do
887 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 982 [[ -f "$script" ]] && [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
888 done 983 done
889 984
890 fi 985 fi
891 986
892 mysql_lib_symlinks "${D}" 987 mysql_lib_symlinks "${D}"
926 for script in \ 1021 for script in \
927 support-files/my-*.cnf \ 1022 support-files/my-*.cnf \
928 support-files/magic \ 1023 support-files/magic \
929 support-files/ndb-config-2-node.ini 1024 support-files/ndb-config-2-node.ini
930 do 1025 do
1026 [[ -f "${script}" ]] \
931 dodoc "${script}" 1027 && dodoc "${script}"
932 done 1028 done
933 1029
934 docinto "scripts" 1030 docinto "scripts"
935 for script in scripts/mysql* ; do 1031 for script in scripts/mysql* ; do
1032 [[ -f "${script}" ]] \
936 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 1033 && [[ "${script%.sh}" == "${script}" ]] \
1034 && dodoc "${script}"
937 done 1035 done
938 1036
939 einfo 1037 einfo
940 elog "You might want to run:" 1038 elog "You might want to run:"
941 elog "\"emerge --config =${CATEGORY}/${PF}\"" 1039 elog "\"emerge --config =${CATEGORY}/${PF}\""
942 elog "if this is a new install." 1040 elog "if this is a new install."
943 einfo 1041 einfo
944 fi 1042 fi
945 1043
946 if mysql_version_is_at_least "5.1.12" && use pbxt ; then 1044 if pbxt_available && use pbxt ; then
947 # TODO: explain it better 1045 # TODO: explain it better
948 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';" 1046 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
949 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;" 1047 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
950 elog "if, after that, you cannot start the MySQL server," 1048 elog "if, after that, you cannot start the MySQL server,"
951 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then" 1049 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then"

Legend:
Removed from v.1.130  
changed lines
  Added in v.1.137

  ViewVC Help
Powered by ViewVC 1.1.20